/* eslint-disable no-multi-str */

(function poll() {
  if (typeof ynabToolKit !== 'undefined' && ynabToolKit.pageReady === true) {
    ynabToolKit.collapseSideMenu = (function () {
      // Supporting functions,
      // or variables, etc

      return {
        collapseBtn:
        $('<li>', { class: 'ember-view navlink-collapse' }).append(
          $('<a>', { href: '#' }).append(
            $('<span>', { class: 'ember-view flaticon stroke left-circle-4' })
          ).append(
            (ynabToolKit.l10nData && ynabToolKit.l10nData['toolkit.collapse']) || 'Collapse'
          )
        ),

        originalButtons: {},

        originalSizes: {
          sidebarWidth: 0,
          contentLeft: 0,
          headerLeft: 0,
          contentWidth: 0,
          inspectorWidth: 0
        },

        setOriginalSizes() {
          ynabToolKit.collapseSideMenu.originalSizes = ({
            sidebarWidth: $('.sidebar').width(),
            contentLeft: $('.content').css('left'),
            headerLeft: $('.budget-header, .accounts-header').css('left'),
            contentWidth: $('.budget-content').css('width'),
            inspectorWidth: $('.budget-inspector').css('width')
          });
        },

        invoke() {
          ynabToolKit.collapseSideMenu.setupBtns();
        },

        observe(changedNodes) {
          if (changedNodes.has('layout user-logged-in')) {
            if ($('.nav-main').length) {
              ynabToolKit.collapseSideMenu.setupBtns();
            }
          }

          changedNodes.forEach(function (changedNode) {
            if ($('.collapsed-buttons').is(':visible') &&
                changedNode.startsWith('navlink-') && changedNode.endsWith(' active')) {
              ynabToolKit.collapseSideMenu.setCollapsedSizes();
              ynabToolKit.collapseSideMenu.setActiveButton();
            }
          });

          if (changedNodes.has('nav-main')) {
            var numNavLinks = $('.nav-main').children().length;
            var collapseIndex = $('.nav-main').children()
              .index($('.navlink-collapse'));

            if (numNavLinks > (collapseIndex + 1)) {
              $('.navlink-collapse').remove();

              ynabToolKit.collapseSideMenu.setUpCollapseBtn();
              ynabToolKit.collapseSideMenu.setUpCollapsedButtons();
            }
          }
        },

        // Add buttons and handlers to screen
        setupBtns() {
          // Don't proceed if buttons already exist
          if ($('.navlink-collapse').is(':visible') ||
              $('.navbar-expand').is(':visible')) {
            return;
          }

          ynabToolKit.collapseSideMenu.setUpCollapseBtn();
          ynabToolKit.collapseSideMenu.setUpCollapsedButtons();
        },

        setUpCollapseBtn() {
          $('.nav-main').append(ynabToolKit.collapseSideMenu.collapseBtn);
          $('.navlink-collapse').on('click',
            ynabToolKit.collapseSideMenu.collapseMenu);
        },

        setUpCollapsedButtons() {
          var expandBtns = ynabToolKit.collapseSideMenu.getUnCollapseBtnGroup();

          if (!$('.collapsed-buttons').length) {
            $('.sidebar').prepend(expandBtns);
          } else {
            $('.collapsed-buttons').remove();
            $('.sidebar').prepend(expandBtns);
          }

          if ($('.sidebar-contents').is(':visible')) {
            $('.collapsed-buttons').hide();
          }
        },

        getUnCollapseBtnGroup() {
          var navChildren = $('.nav-main').children();
          var navChildrenLength = navChildren.length;

          var collapsedBtnContainer =
            $('<div>', {
              class: 'collapsed-buttons'
            });

          var clickFunction = function () {
            ynabToolKit.collapseSideMenu.originalButtons[this.className.replace(' active', '')].click();
          };

          for (var i = 0; i < navChildrenLength; i++) {
            var child = navChildren[i];

            // If this is the collapse button, skip
            if (child.className.indexOf('navlink-collapse') > -1) {
              continue;
            }

            var span = $(child).find('span')[0];

            // Don't process if not actually a button
            if (!span) {
              continue;
            }

            var btnClasses = span.className;
            var button = $('<button>');
            button.addClass(btnClasses);
            button.addClass('button button-prefs');

            var listItem = $(child).find('li')[0] || child;
            var linkClasses = listItem.className.replace(' active', '');

            var link = $('<a>');
            link.attr('href', '#');
            link.addClass(linkClasses);
            link.html(button);
            link.click(clickFunction);

            ynabToolKit.collapseSideMenu.originalButtons[linkClasses.replace(' active', '')] = $(child).find('a');

            // Set proper class so the active styling can be applied
            if (btnClasses.indexOf('mail-1') > -1) {
              button.addClass('collapsed-budget');
            } else if (btnClasses.indexOf('government-1') > -1) {
              button.addClass('collapsed-account');
            } else {
              // Fallback if we don't know what the button is.
              button.addClass('collapsed');
            }

            collapsedBtnContainer.append(link);
          }

          // Add uncollapse button
          var collapseBtn = $('<button>');
          collapseBtn.addClass('button button-prefs flaticon stroke \
            right-circle-4 navbar-expand');

          collapsedBtnContainer.append(collapseBtn);

          $('body').on('click', '.navbar-expand', function () {
            ynabToolKit.collapseSideMenu.expandMenu(ynabToolKit.collapseSideMenu.originalSizes);
          });

          return collapsedBtnContainer;
        },

        // Handle clicking expand button. Puts things back to original sizes
        expandMenu(originalSizes) {
          $('.collapsed-buttons').hide();
          $('.sidebar > .ember-view').fadeIn();
          $('.navlink-collapse').show();
          $('.sidebar').animate({ width: originalSizes.sidebarWidth });
          $('.content').animate({ left: originalSizes.contentLeft });
          $('.budget-header').animate({ left: originalSizes.headerLeft });
          $('.budget-content').animate({ width: originalSizes.contentWidth }, 400, 'swing', function () {
            // Need to remove width after animation completion IF resize-inspector feature not on
            if (!ynabToolKit.options.resizeInspector) {
              $('.budget-content').removeAttr('style');
            }

            // We don't use these in our CSS, it's mostly so other features can observe
            // for collapse/expand and update sizes / do whatever. E.g. reports needs
            // to resize its canvas when this happens.
            $('.navlink-collapse').removeClass('collapsed').addClass('expanded');
          });

          // Need to resize the inspector section IF resize-inspector feature not on
          if (!ynabToolKit.options.resizeInspector) {
            $('.budget-inspector').animate({ width: originalSizes.inspectorWidth });
          }
        },

        // Handle clicking the collapse button
        collapseMenu() {
          // resize-inspector feature could have changed these so fetch current sizes.
          ynabToolKit.collapseSideMenu.setOriginalSizes();
          ynabToolKit.collapseSideMenu.setActiveButton();
          $('.navlink-collapse').hide();
          $('.sidebar > .ember-view').hide();
          $('.collapsed-buttons').fadeIn();
          ynabToolKit.collapseSideMenu.setCollapsedSizes();
        },

        // Set collapsed sizes
        setCollapsedSizes() {
          $('.sidebar').animate({ width: '40px' });
          $('.content').animate({ left: '40px' }, 400, 'swing', function () {
            // Need to remove width after animation completion
            $('.ynab-grid-header').removeAttr('style');

            // We don't use these in our CSS, it's mostly so other features can observe
            // for collapse/expand and update sizes / do whatever. E.g. reports needs
            // to resize its canvas when this happens.
            $('.navlink-collapse').removeClass('expanded').addClass('collapsed');
          });

          $('.budget-header').animate({ left: '40px' });

          if (ynabToolKit.options.resizeInspector) { // just stretch to the left preserving the users inspector width
            let $width = parseInt($('.budget-content').css('width').match(/.[^px]*/)) +
                         parseInt($('.budget-inspector').css('width').match(/.[^px]*/)) -
                         parseInt($('.inspector-resize-handle').css('width').match(/.[^px]*/)) - 40;

            $('.budget-content').animate({ width: $width });
          } else {
            $('.budget-content').animate({ width: '73%' });
            $('.budget-inspector').animate({ width: '27%' });
          }
        },

        // Add the active style to correct button
        setActiveButton() {
          ynabToolKit.collapseSideMenu.deactivateCollapsedActive();

          var originalButtons = ynabToolKit.collapseSideMenu.originalButtons;

          for (var classList in originalButtons) {
            if (originalButtons.hasOwnProperty(classList)) {
              var originalButton = $(originalButtons[classList]).closest('.ember-view');

              if (originalButton.hasClass('active')) {
                // Set the active button in the collapsed panel.
                var collapsedSelector = '.collapsed-buttons .' +
                        $(originalButton).attr('class')
                          .replace(' active', '')
                          .replace(' ', '.') +
                            ' button';

                $(collapsedSelector).addClass('collapsed-active');
              }
            }
          }
        },

        // Deactivate collapsed buttons
        deactivateCollapsedActive() {
          $('.collapsed-buttons a button').removeClass('collapsed-active');
          $('.collapsed-buttons a').removeClass('active');
        }
      };
    }()); // Keep feature functions contained within this object

    ynabToolKit.collapseSideMenu.invoke();
  } else {
    setTimeout(poll, 250);
  }
}());
